//* Базовые операторы

// const a = 5;
// const b = 10;

//
// console.log(a + b);
// console.log(a - b);
// console.log(a * b);
// console.log(a / b);
// console.log(a % b); // взятие остатка от деления
// console.log(a ** b); // возведение в степень

//* Операнд - то, к чему применяется оператор
// (правый операнд) 5 * 2 (левый операнд)

// Унарным называется оператор, который применяется к одному операнду (a = -a)
// Бинарным называется оператор, который применяется к двум операндам (a - b)

//* Инкримент и декримент

// console.log(a++); // инкримент
// console.log(a--); // декримент

// Когда оператор идёт после переменной — это «постфиксная форма» //* a++
// Возвращает старое значение (до увеличения/уменьшения числа).

// «Префиксная форма» — это когда оператор идёт перед переменной //* ++a
// Возвращает новое значение

// let a = 1, b = 1

// let c = ++a
// let d = b++

// a // 2
// b // 2
// c // 2
// d // 1

//-----------------------------------------------------------------------------------------

//* Операторы сравнения
// Результат сравнения всегда имеет логический тип (true / false)

// Больше, меньше a > b, a < b
// Больше, меньше или равно a >= b, a <= b
// Равно a == b
// Строгое равно a === b
// Не равно a !== b

// При строгом сравнении - `===` - сначала проверяются на соответствие типы данных. Если они совпали - сравниваются значения
// console.log('22' === 22) // false

// При сравнении значений разных типов JavaScript приводит каждое из них к числу
// Логическое значение true становится 1, а false – 0
// При нестрогом сравнении Null == 0, undefined == NaN
// undefined равно только null (при нестрогом сравнении), undefined и ничему больше
// -1 в логическом контексте true

// a ?? b
// оператор ?? возвращает первый аргумент, если он не null/undefined, иначе второй

// let user;
// alert(user ?? "Аноним");
// Если user undefuned или null, покажеться 'Аноним'

//* Сравнение строк

// Строки сравниваются посимвольно.
// Сначала сравниваются первые символы строк.
// Если первый символ первой строки больше (меньше), чем первый символ второй, то первая строка больше (меньше) второй.
// Если первые символы равны, то таким же образом сравниваются уже вторые символы строк.
// Сравнение продолжается, пока не закончится одна из строк.
// Если обе строки заканчиваются одновременно, то они равны. Иначе, большей считается более длинная строка.
